# stdafx.h File Reference

Definition of base types and functions in a cross-platform compatible way. More...

`#include <stdint.h>`
`#include <cstdio>`
`#include <cstddef>`
`#include <cstring>`
`#include <cstdlib>`
`#include <climits>`
`#include <cassert>`

Go to the source code of this file.

## Defines
#define | __STDC_LIMIT_MACROS
#define | fopen(file, mode) fopen(OTTD2FS(file), mode)
#define | SQ2OTTD(name) (name)
#define | OTTD2SQ(name) (name)
#define | PATHSEP "/"
#define | PATHSEPCHAR '/'
#define | OTTD_PRINTF64 "%lld"
#define | OTTD_PRINTFHEX64 "%llx"
#define | PRINTF_SIZE "%zu"
#define | PERSONAL_DIR ""
#define | assert_compile(expr) typedef int __ct_assert__[1 - 2 * !(expr)]
#define | assert_tcompile(expr) assert(expr)
#define | lengthof(x) (sizeof(x) / sizeof(x[0]))
| Return the length of an fixed size array.
#define | endof(x) (&x[lengthof(x)])
| Get the end element of an fixed size array.
#define | lastof(x) (&x[lengthof(x) - 1])
| Get the last element of an fixed size array.
#define | cpp_offsetof(s, m) (((size_t)&reinterpret_cast<const volatile char&>((((s*)(char*)8)->m))) - 8)
#define | offsetof(s, m) cpp_offsetof(s, m)
#define | NOT_REACHED() error("NOT_REACHED triggered at line %i of %s", __LINE__, __FILE__)
#define | assert(expression) if (!(expression)) error("Assertion failed at line %i of %s: %s", __LINE__, __FILE__, #expression);
#define | MAX_PATH PATH_MAX
#define | MAX_UVALUE(type) ((type)~(type)0)
| The largest value that can be entered in a variable.
## Typedefs
typedef unsigned char | byte
typedef unsigned int | uint
typedef unsigned char | uint8
typedef signed char | int8
typedef unsigned short | uint16
typedef signed short | int16
typedef unsigned int | uint32
typedef signed int | int32
typedef unsigned __int64 | uint64
typedef signed __int64 | int64
## Functions
const char * | FS2OTTD (const char *name)
const char * | OTTD2FS (const char *name)
| Convert from OpenTTD's encoding to that of the local environment.
| assert_compile (sizeof(uint64)==8)
| assert_compile (sizeof(uint32)==4)
| assert_compile (sizeof(uint16)==2)
| assert_compile (sizeof(uint8)==1)
void NORETURN CDECL | usererror (const char *str,...) WARN_FORMAT(1
void NORETURN CDECL void NORETURN CDECL | error (const char *str,...) WARN_FORMAT(1

## Detailed Description

Definition of base types and functions in a cross-platform compatible way.

Definition in file stdafx.h.

## Define Documentation

#define endof | ( | x |  | ) | (&x[lengthof(x)])

Get the end element of an fixed size array.

Parameters:

  | x | The pointer to the first element of the array

Returns:
  The pointer past to the last element of the array

Definition at line 355 of file stdafx.h.

Referenced by DrawCargoListText(), SmallStackSafeStackAlloc< T, length >::EndOf(), GetDebugString(), GetSavegameFormat(), GrowTown(), HandleCrash(), CrashLog::InitialiseCrashLog(), LoadFromHighScore(), SaveOrLoad(), SaveToHighScore(), ShowRefitOptionsList(), TerraformTileHeight(), VehicleGroupWindow::UpdateWidgetSize(), and SelectCompanyLiveryWindow::UpdateWidgetSize().

#define lastof | ( | x |  | ) | (&x[lengthof(x) - 1])

Get the last element of an fixed size array.

Parameters:

  | x | The pointer to the first element of the array

Returns:
  The pointer to the last element of the array

Definition at line 363 of file stdafx.h.

Referenced by ScenarioScanner::AddFile(), FiosFileScanner::AddFile(), TarScanner::AddFile(), NetworkChatWindow::ChatTabCompletionNextItem(), CheckExternalFiles(), CloneVehicleName(), CmdFoundTown(), CopyFromOldName(), DEF_UDP_RECEIVE_COMMAND(), CrashLogOSX::DisplayCrashDialog(), DoAutosave(), DrawCargoListText(), NetworkContentListWindow::DrawDetails(), DrawNewsString(), DrawRoadVehDetails(), DrawString(), DrawStringMultiLine(), CheatWindow::DrawWidget(), ExtractTar(), FindUnknownGRFName(), FioFOpenFile(), FiosGetFileList(), FS2OTTD(), GamelogRevision(), NetworkAddress::GetAddressAsString(), GetAllCargoSuffixes(), GetDebugString(), GetFileTitle(), GetFullFilename(), GetKeyboardLayout(), GetSavegameFormat(), GetSaveLoadErrorString(), GetStringBoundingBox(), GetStringHeight(), VehicleGroupWindow::GroupNameSorter(), HandleSavegameLoadCrash(), HashCurrentCompanyPassword(), HelpDialogFunc(), IndustryDirectoryWindow::IndustryNameSorter(), ini_save_settings(), IsGoodGRFConfigList(), IsSameAI(), AIInstance::LoadCompatibilityScripts(), LoadFromHighScore(), CrashLogOSX::MakeCrashLog(), CrashLog::MakeCrashLog(), MakeScreenshot(), NetworkAddChatMessage(), NetworkAddress::NetworkAddress(), NetworkFindBroadcastIPsInternal(), NetworkGameListHandleDelayedInsert(), NetworkHandlePauseChange(), NetworkSend_Command(), NetworkServerChangeClientName(), NetworkUDPQueryServerThread(), NewGRFWindow::OnClick(), NetworkStartServerWindow::OnClick(), SaveLoadWindow::OnClick(), NetworkContentDownloadStatusWindow::OnDownloadProgress(), NetworkStartServerWindow::OnKeyPress(), NetworkGameWindow::OnKeyPress(), CustomCurrencyWindow::OnQueryTextFinished(), NetworkStartServerWindow::OnQueryTextFinished(), ClientNetworkContentSocketHandler::OnReceiveData(), DepotWindow::OnRightClick(), OTTD2FS(), PrintGrfInfo(), DriverFactoryBase::RegisterDriver(), NetworkAddress::Resolve(), SaveHighScoreValue(), IniFile::SaveToDisk(), FileScanner::Scan(), DriverFactoryBase::SelectDriver(), SetFallbackFont(), ShowHelp(), ShowNewGrfVehicleError(), ShowRefitOptionsList(), SignList::SignNameSorter(), CompanyStationsWindow::StationNameSorter(), TownDirectoryWindow::TownNameSorter(), NetworkContentListWindow::TypeSorter(), ViewportSign::UpdatePosition(), VehicleNameSorter(), VerifyTownName(), and DriverFactoryBase::~DriverFactoryBase().

#define lengthof | ( | x |  | ) | (sizeof(x) / sizeof(x[0]))

Return the length of an fixed size array.

Unlike sizeof this function returns the number of elements of the given type.

Parameters:

  | x | The pointer to the first element of the array

Returns:
  The number of elements

Definition at line 347 of file stdafx.h.

Referenced by _GenerateWorld(), AddGenericCallback(), AddGRFString(), AddNewsItem(), AICargoList_IndustryAccepting::AICargoList_IndustryAccepting(), AICargoList_IndustryProducing::AICargoList_IndustryProducing(), AIIndustryList_CargoAccepting::AIIndustryList_CargoAccepting(), AIIndustryList_CargoProducing::AIIndustryList_CargoProducing(), AITileList_IndustryAccepting::AITileList_IndustryAccepting(), AITileList_IndustryProducing::AITileList_IndustryProducing(), NWidgetServerListHeader::AssignSizePosition(), CalcHeightdiff(), AIRoad::CanBuildConnectedRoadPartsHere(), CanCargoServiceIndustry(), ChangeIndustryProduction(), NetworkChatWindow::ChatTabCompletion(), CmdChangeCompanySetting(), CmdDoTownAction(), CmdFoundTown(), CmdRenamePresident(), CMSAForest(), CMSAMine(), Squirrel::CompileError(), ScriptFileInfo::Constructor(), DeliverGoodsToIndustry(), DeterminePaths(), DoCommandPInternal(), DoScanWorkingDirectory(), DrawEngineList(), IndustryViewWindow::DrawInfo(), DrawNewsString(), NewsWindow::DrawWidget(), ErrmsgWindow::DrawWidget(), AboutWindow::DrawWidget(), BuildIndustryWindow::DrawWidget(), CompanyWindow::DrawWidget(), CheatWindow::DrawWidget(), error(), Squirrel::ErrorPrintFunc(), ExtractTar(), FindIndustryToDeliver(), FiosGetFileList(), FixTTOEngines(), FormatBytes(), FS2OTTD(), GenerateCompanyPasswordHash(), GenerateIndustries(), GenerateTownNameString(), CargoSpec::Get(), AIIndustryType::GetAcceptedCargo(), GetAllCargoSuffixes(), CargoSpec::GetArraySize(), NWidgetScenarioToolbarContainer::GetButtonArrangement(), NWidgetMainToolbarContainer::GetButtonArrangement(), IndustryDirectoryWindow::GetCargoTransportedPercentsIfValid(), GetCurrentLocale(), GetDistanceFromNearbyHouse(), GetDParam(), GetFullFilename(), GetGenericCallbackResult(), IndustryDirectoryWindow::GetIndustryString(), AIIndustry::GetLastMonthProduction(), AIIndustry::GetLastMonthTransported(), AIIndustry::GetLastMonthTransportedPercentage(), GetMaskOfTownActions(), GetNetworkErrorMsg(), GetNewgrfCurrencyIdConverted(), GRFFile::GetParam(), AIIndustryType::GetProducedCargo(), GetProductionAroundTiles(), AIIndustry::GetStockpiledCargo(), GetVehicleSpriteGroup(), GraphicsNew(), HandleBiDiAndArabicShapes(), HelpDialogFunc(), IConsoleAliasExec(), IConsoleCmdExec(), IConsoleListSettings(), IndustryDirectoryWindow::IndustryProductionSorter(), InitializeLanguagePacks(), InitializeUnicodeGlyphMap(), InjectDParam(), InsertTextBufferClipboard(), AIIndustry::IsCargoAccepted(), SmallSet< Tdir, items >::IsFull(), IsValidCommand(), NWidgetServerListHeader::IsWidgetVisible(), load_intlist(), CrashLogWindows::LogModules(), CrashLogUnix::LogStacktrace(), LookupWithBuildOnSlopes(), MakeAustrianTownName(), MakeCatalanTownName(), MakeCzechTownName(), MakeDanishTownName(), MakeDutchTownName(), MakeEnglishAdditionalTownName(), MakeEnglishOriginalTownName(), MakeFinnishTownName(), MakeFrenchTownName(), MakeGermanTownName(), MakeHungarianTownName(), MakeItalianTownName(), MakeNorwegianTownName(), MakePerformanceDetailPanels(), MakePolishTownName(), MakeRomanianTownName(), MakeSillyTownName(), MakeSlovakTownName(), MakeSpanishTownName(), MakeSwedishTownName(), MakeSwissTownName(), MakeTurkishTownName(), NetworkAddChatMessage(), NewGRFWindow::OnClick(), NetworkStartServerWindow::OnClick(), CheatWindow::OnClick(), BuildAirToolbarWindow::OnClick(), SmallMapWindow::OnInit(), ScenarioEditorLandscapeGenerationWindow::OnKeyPress(), TerraformToolbarWindow::OnKeyPress(), BuildRoadToolbarWindow::OnKeyPress(), BuildRailToolbarWindow::OnKeyPress(), OrdersWindow::OnKeyPress(), MainWindow::OnPaint(), HighScoreWindow::OnPaint(), NewGRFWindow::OnQueryTextFinished(), AboutWindow::OnTick(), OTTD2FS(), Squirrel::PrintFunc(), NetworkHTTPSocketHandler::Receive(), NetworkClientSocket::Recv_Command(), RemapTTOColour(), ResetGenericCallbacks(), Squirrel::RunError(), SaveHighScoreValue(), SaveOrLoad(), SaveVersionInConfig(), FileScanner::Scan(), ScanPath(), DriverFactoryBase::SelectDriver(), NetworkClientSocket::Send_Command(), SetDParam(), QueryWindow::SetStringParameters(), ErrmsgWindow::SetStringParameters(), SetupCargoForClimate(), NWidgetScenarioToolbarContainer::SetupSmallestSize(), SmallMapWindow::SetZoomLevel(), ShowInfoF(), SlCalcConvFileLen(), SlCalcConvMemLen(), StateGameLoop(), StringToContentType(), TriggerIndustryProduction(), UpdateStationAcceptance(), VehicleDetailsWindow::UpdateWidgetSize(), NewsWindow::UpdateWidgetSize(), ErrmsgWindow::UpdateWidgetSize(), AboutWindow::UpdateWidgetSize(), BuildIndustryWindow::UpdateWidgetSize(), CompanyLeagueWindow::UpdateWidgetSize(), CompanyWindow::UpdateWidgetSize(), CheatWindow::UpdateWidgetSize(), and usererror().

#define MAX_UVALUE | ( | type |  | ) | ((type)~(type)0)

The largest value that can be entered in a variable.

Parameters:

  | type | the type of the variable

Definition at line 413 of file stdafx.h.

Referenced by Town::GetRandom(), Industry::GetRandom(), HandleBankruptcyTakeover(), Scrollbar::SetCapacity(), Scrollbar::SetCount(), and IConsoleLine::Truncate().

## Function Documentation

const char* OTTD2FS | ( | const char * | name | ) |

Convert from OpenTTD's encoding to that of the local environment.

When the project is built in UNICODE the system codepage is irrelevant and the converted string is wide. In ANSI mode, the UTF8 string is converted to multi-byte. OpenTTD internal encoding is UTF8. The returned value's contents can only be guaranteed until the next call to this function. So if the value is needed for anything else, use convert_from_fs

Parameters:

  | name | pointer to a valid string that will be converted (UTF8)

Returns:
  pointer to the converted string; if failed string is of zero-length

See also:
  the current code-page comes from video\win32_v.cpp, event-notification WM_INPUTLANGCHANGE

Definition at line 213 of file os2.cpp.

References convert_to_fs(), lastof, and lengthof.